Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Interface FunctionLibrary

All Superinterfaces:
  Serializable

All Known Subinterfaces:
  XQueryFunctionBinder

All Known Implementing Classes:
  ConstructorFunctionLibrary, ExecutableFunctionLibrary, ExtraFunctionLibrary, FunctionLibraryList, ImportedFunctionLibrary, JavaExtensionLibrary, StylesheetFunctionLibrary, SystemFunctionLibrary, UnboundFunctionLibrary, VendorFunctionLibrary, XPathFunctionLibrary, XQueryFunctionLibrary

    public interface FunctionLibrary

extends Serializable

A FunctionLibrary handles the binding of function calls in XPath (or XQuery) expressions. There are a number of implementations of this class to handle different kinds of function: system functions, constructor functions, vendor-defined functions, Java extension functions, stylesheet functions, and so on. There is also an implementation `FunctionLibraryList` that allows a FunctionLibrary to be constructed by combining other FunctionLibrary objects.

Method Summary
`Expression` | `bind(int nameCode, String uri, String local, Expression[] staticArgs)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`boolean` | `isAvailable(int fingerprint, String uri, String local, int arity)` Test whether an extension function with a given name and arity is available.

Method Detail

### isAvailable

    boolean isAvailable(int fingerprint,
                        String uri,
                        String local,
                        int arity)

  Test whether an extension function with a given name and arity is available. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time. If the function library is to be used only in an XQuery or free-standing XPath environment, this method may throw an UnsupportedOperationException.

  Parameters:
    `fingerprint` - The namepool fingerprint of the function name. This must match the uri and localName; the information is provided redundantly to avoid repeated lookups in the name pool.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function; in this case the method should return true if there is some matching extension function, regardless of its arity.

### bind

    Expression bind(int nameCode,
                    String uri,
                    String local,
                    Expression[] staticArgs)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Parameters:
    `nameCode` - The namepool nameCode of the function name. The uri and local name are also supplied (redundantly) to avoid fetching them from the name pool.
    `uri` - The URI of the function name
    `local` - The local part of the function name
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.

    The conventions of the XPath language demand that the results of a function depend only on the values of the expressions supplied as arguments, and not on the form of those expressions. For example, the result of f(4) is expected to be the same as f(2+2). The actual expression is supplied here to enable the binding mechanism to select the most efficient possible implementation (including compile-time pre-evaluation where appropriate).

  Returns:
    An object representing the function to be called, if one is found; null if no function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### copy

    FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.